/****************************************************************************
    LCoV library editor for BSch3V
    Copyright (C) 2004-2005 H.Okada (http://www.suigyodo.com/online)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*****************************************************************************/


///////////////////////////////////////////////////////////
// BSch̃tHgNX̃Cvg

#include "stdafx.h"
#include "draw.h"
#include "BSchFont.h"
#include <assert.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


////////////////////////////////////////////////////////////////////////////////
// CBSchFont ̃RXgN^
CBSchFont::CBSchFont()
{
	Init88Font();
	//InitWinFont();
	//m_pBmpBit=new unsigned char [4096];
	m_pFontHLabel = NULL;
	m_pFontVLabel = NULL;
	m_VExt =-1;
	m_WExt =-1;
}

////////////////////////////////////////////////////////////////////////////////
// CBSchFont ̃fXgN^
CBSchFont::~CBSchFont()
{
	delete m_pFontHLabel;
	delete m_pFontVLabel;
	//delete[]m_pBmpBit;
}

// W~WhbgtHg̏
void CBSchFont::Init88Font()
{
	g_IniReadLabelFontInfo(&m_logfontLabel);
}


LOGFONT CBSchFont::logfontLabel()
{
	return m_logfontLabel;
}

void  CBSchFont::setLogFontLabel(LOGFONT lf)
{
	m_logfontLabel = lf;
	m_VExt =-1;
	m_WExt =-1;
}




//	BSch̃x̕`
//  \̃Y[ɑΉ邽߁AO[oϐ g_nVExtAg_nWExt QƂĂ
//  kEg\(nVExt!=nWExt)̂Ƃ͕񑊓̕lp`ŕ\B
//      *BSchł͊g\T|[gĂȂB
CSize CBSchFont::PutFont(	
		CDC* pDC,						//o͐̃foCXReLXg
		int x,int y,					//o͈ʒu
		LPCSTR lpstr,					//o͕
		int nStrLen		/* =-1		*/,	//
		COLORREF col	/* =RGB(255,255,255) */,	//o͐F
		UINT nMode		/* =DRAW_ON */,	//`惂[h
		BOOL bVert		/* =FALSE 	*/,	//tO
		int  nPointPos	/* =0  		*/,	//w肵o͈ʒu 0:̑O 1:̌ 2:̒
										//					 0:̉ 4:̏   8:̒
		int  nVExt		/* =1		*/,	//\{(View)
		int  nWExt		/* =1		*/, //\{(Window)
		BOOL bUseUpperLine)

{
	COLORREF colOldText,colOldBk;
	CSize size,sizeLog;
	int      nOldBkMode;
	CFont *pFont;
	char buff[1024];

	bool upperLine=false;
	const char *pch;
	char ch;
	if(nStrLen>1024 || nStrLen<0){
		nStrLen=1024;
	}
	
	for(pch = lpstr,m_nStrLen = 0; *pch !='\0' && m_nStrLen<nStrLen;pch++, m_nStrLen++){
		ch = *pch;
		if(ch & 0x80){
			upperLine = true;
			ch &= 0x7f;
		}
		if(ch<0x20 || ch>0x7e) ch = ' ';
		buff[m_nStrLen]=ch;
	}
	buff[m_nStrLen]='\0';


//	if(nStrLen<0) m_nStrLen=lstrlen(lpstr);		//񒷂̐ݒ
//	else		  m_nStrLen=nStrLen;
	if(m_nStrLen==0) return CSize(0,0);		//񒷂OȂ牽Ȃ
//	if(m_nStrLen>255) m_nStrLen=255;//񒷂͍ő255
	



	if(nVExt != m_VExt || nWExt != m_WExt||m_pFontHLabel==NULL||m_pFontVLabel==NULL){
		delete m_pFontHLabel;
		delete m_pFontVLabel;
		m_pFontHLabel = new CFont;
		m_pFontVLabel = new CFont;
		LOGFONT lf = m_logfontLabel;
		if(lf.lfHeight>0) lf.lfHeight = -lf.lfHeight;
		lf.lfOutPrecision = OUT_TT_ONLY_PRECIS;	
		lf.lfHeight = lf.lfHeight*nVExt/nWExt;
		m_pFontHLabel->CreateFontIndirect(&lf);	//tHgNX̏
		lf.lfEscapement = 900;
		lf.lfOrientation = 900;
		m_pFontVLabel->CreateFontIndirect(&lf);	//tHgNX̏
		m_VExt = nVExt;
		m_WExt = nWExt;
		if(bVert){
			pFont=pDC->SelectObject(m_pFontVLabel);			//tHg̑I
		}else{
			pFont=pDC->SelectObject(m_pFontHLabel);			//tHg̑I
		}
		TEXTMETRIC tm;
		pDC->GetTextMetrics(&tm);
		m_vOffset = tm.tmHeight - tm.tmDescent;
	}else{
		if(bVert){
			pFont=pDC->SelectObject(m_pFontVLabel);			//tHg̑I
		}else{
			pFont=pDC->SelectObject(m_pFontHLabel);			//tHg̑I
		}
	}

	size=pDC->GetTextExtent(buff,m_nStrLen);			//`TCY𓾂
	x=x*nVExt/nWExt;
	y=y*nVExt/nWExt;

	int nPointPosH = nPointPos&3;
	int nPointPosV = (nPointPos>>2)&3;
	int vOffset;

	if(nPointPosV == 0){
		vOffset = m_vOffset;
	}else if(nPointPosV == 1){
		vOffset = 0;
	}else{
		vOffset = m_vOffset/2;
	}

	if(bVert){
		x-=vOffset;
		if(nPointPosH == 1){
			y+=size.cx;
		}else if(nPointPosH == 2){
			y+=size.cx/2;
		}
	}else{
		y-=vOffset;
		if(nPointPosH == 1){
			x-=size.cx;
		}else if(nPointPosH == 2){
			x-=size.cx/2;
		}
	}

	colOldText	= pDC->SetTextColor(col);			//TextColor̐ݒ
	nOldBkMode  = pDC->SetBkMode(TRANSPARENT);		//`͓߃[h
	pDC->TextOut(x,y,buff,m_nStrLen);				//`
	sizeLog=size;
	if(bUseUpperLine && upperLine){
		CPen penNew;
		CPen* ppenOld;
		int penWidth = nVExt/nWExt;
		//`惂[hɂăy̎ށEFCOPY or XORݒ肷
		penNew.CreatePen(PS_SOLID,penWidth,col);
		ppenOld=pDC->SelectObject(&penNew);			//쐬y̑I
		int i,begin,end;
		int lx,ly;
		if(bVert){
			lx = x;
		}else{
			ly = y;
		}
		i=0;
		while(i<m_nStrLen){
			if(lpstr[i]&0x80){
				size=pDC->GetTextExtent(buff,i);
				begin = size.cx;
				i++;
				while(i<m_nStrLen && lpstr[i]&0x80){
					i++;
				}
				size=pDC->GetTextExtent(buff,i);
				end = size.cx;	
				//TRACE("%d->%d\n",begin,end);
				if(bVert){
					pDC->MoveTo(lx,y-begin);
					pDC->LineTo(lx,y-end);
				}else{
					pDC->MoveTo(x+begin,ly);
					pDC->LineTo(x+end,ly);
				}
			}
			i++;
		}
		pDC->SelectObject(ppenOld);
	}

	
//	if(nMode&DRAW_ON || nMode&DRAW_TEMP){
//		colOldText	= pDC->SetTextColor(col);			//TextColor̐ݒ
//		nOldBkMode  = pDC->SetBkMode(TRANSPARENT);		//`͓߃[h
//		pDC->TextOut(x,y,buff,m_nStrLen);				//`
//		pDC->SetBkMode(nOldBkMode);						//wi`惂[h̕A
//		pDC->SetTextColor(colOldText);					//TextColor̕A
//	}else if(nMode&DRAW_OFF){
//		assert(0);
//		colOldText	= pDC->SetTextColor(0);				//TextColor̐ݒiŕ`j
//		nOldBkMode  = pDC->SetBkMode(TRANSPARENT);		//`͓߃[h
//		pDC->TextOut(x,y,buff,m_nStrLen);				//`
//		pDC->SetBkMode(nOldBkMode);						//wi`惂[h̕A
//		pDC->SetTextColor(colOldText);					//TextColor̕A
//	}else{
//		TRACE("\nsȕ`惂[h(CBSchFont::PutWinFont())");
//	}
	pDC->SetBkMode(nOldBkMode);						//wi`惂[h̕A
	pDC->SetTextColor(colOldText);					//TextColor̕A
	pDC->SelectObject(pFont);						//tHg̕A
	
	return sizeLog;
}

/****************************************************************************
	RgpWindowstHg̕`
****************************************************************************/
CSize CBSchFont::PutWinFont(
		CDC* pDC,					//o͐̃foCXReLXg
		int x,int y,					//o͈ʒu
		LPCSTR lpstr,					//o͕
		int nStrLen /* =-1		*/,		//
		LOGFONT* plf,
		COLORREF col/* =RGB(255,255,255) */,		//o͐F
		UINT nMode	/* =DRAW_ON */,		//`惂[h
		BOOL bVert		/* =FALSE 	*/,	//tO
		int  nPointPos	/* =0  		*/,	//w肵o͈ʒu 0:̑O 1:̌ 2:̒
										//					 0:̉ 4:̏   8:̒
		int  nVExt	/* =1		*/,		//\{(View)
		int  nWExt	/* =1		*/)		//\{(Window)

{
	COLORREF colOldText;//,colOldBk;
	int      nOldBkMode;
	CSize	 size,sizeLog;

	if(nStrLen<0) m_nStrLen=lstrlen(lpstr);		//񒷂̐ݒ
	else		  m_nStrLen=nStrLen;
	if(m_nStrLen==0) return CSize(0,0);			//񒷂OȂ牽Ȃ
	if(m_nStrLen>255) m_nStrLen=255;
	
	CFont*	pFont=new CFont;

	LOGFONT lf;
	if(!plf){
		assert(0);
		//lf = m_logfont;
	}else{
		lf = *plf;
	}

	lf.lfOutPrecision = OUT_TT_ONLY_PRECIS;
	
	lf.lfHeight = plf->lfHeight*nVExt/nWExt;
	if(bVert){
		lf.lfEscapement = 900;
		lf.lfOrientation = 900;
	}
	x=x*nVExt/nWExt;
	y=y*nVExt/nWExt;

	pFont->CreateFontIndirect(&lf);	//tHgNX̏
	pFont=pDC->SelectObject(pFont);					//tHg̑I
	size=pDC->GetTextExtent(lpstr,m_nStrLen);		//`TCY𓾂

	int nPointPosH = nPointPos&3;
	int nPointPosV = (nPointPos>>2)&3;
	int vOffset;

	if(nPointPosV == 0){
		vOffset = size.cy;
	}else if(nPointPosV == 1){
		vOffset = 0;
	}else{
		vOffset = size.cy/2;
	}

	if(bVert){
		x-=vOffset;
		if(nPointPosH == 1){
			y+=size.cx;
		}else if(nPointPosH == 2){
			y+=size.cx/2;
		}
	}else{
		y-=vOffset;
		if(nPointPosH == 1){
			x-=size.cx;
		}else if(nPointPosH == 2){
			x-=size.cx/2;
		}
	}



	if(nMode&DRAW_ON || nMode&DRAW_TEMP){
		colOldText	= pDC->SetTextColor(col);			//TextColor̐ݒ
		nOldBkMode  = pDC->SetBkMode(TRANSPARENT);		//`͓߃[h
		pDC->TextOut(x,y,lpstr,m_nStrLen);				//`
		pDC->SetBkMode(nOldBkMode);						//wi`惂[h̕A
		pDC->SetTextColor(colOldText);					//TextColor̕A
	}else if(nMode&DRAW_OFF){
		colOldText	= pDC->SetTextColor(0);				//TextColor̐ݒiŕ`j
		nOldBkMode  = pDC->SetBkMode(TRANSPARENT);		//`͓߃[h
		pDC->TextOut(x,y,lpstr,m_nStrLen);				//`
		pDC->SetBkMode(nOldBkMode);						//wi`惂[h̕A
		pDC->SetTextColor(colOldText);					//TextColor̕A
	}else{
		TRACE("\nsȕ`惂[h(CBSchFont::PutWinFont())");
	}
	pFont=pDC->SelectObject(pFont);					//tHg̕A
	sizeLog=size;
	delete pFont;
	return sizeLog;

}





BOOL CBSchFont::IniReadFontInfo(const char* sectionName, LPLOGFONT lplf,const char* defFont,int defHeight)
{
	int n;
	char *p;
	CString rFaceName;
	
	p=(char*)lplf;	//LOGFONT\̂̂OCjVCY
	for(n=0;n<sizeof(LOGFONT);n++) *p++=0;

	lplf->lfHeight=AfxGetApp()->GetProfileInt(sectionName,"Height",defHeight); 	//tHg̍𓾂B
	lplf->lfWeight=AfxGetApp()->GetProfileInt(sectionName,"IsBold",FW_REGULAR);	//tHg̃EGCg𓾂BftHgl0
	lplf->lfItalic=AfxGetApp()->GetProfileInt(sectionName,"IsItalic",0);		//tHg̃C^bN𓾂BftHgl0
//	lplf->lfCharSet=AfxGetApp()->GetProfileInt(sectionName,"CharSet",SHIFTJIS_CHARSET);	//tHg̃LN^Zbg𓾂BftHglSHIFTJIS_CHARSET
	lplf->lfPitchAndFamily=0;//AfxGetApp()->GetProfileInt(sectionName,"PitchAndFamily",0);	//tHg̃sb`t@~𓾂BftHg0
	rFaceName=AfxGetApp()->GetProfileString(sectionName,"FaceName",defFont);	//tHgFaceName𓾂B
	lstrcpy(lplf->lfFaceName,rFaceName);
	return TRUE;
}

//WXgɃtHg
BOOL CBSchFont::IniWriteFontInfo(const char* sectionName, LPLOGFONT lplf)
{
	AfxGetApp()->WriteProfileInt(sectionName,"Height",abs(lplf->lfHeight));		//tHg̍Zbg
	AfxGetApp()->WriteProfileInt(sectionName,"IsBold",lplf->lfWeight);			//tHg̃EGCgZbg
	AfxGetApp()->WriteProfileInt(sectionName,"IsItalic",lplf->lfItalic);		//tHg̃C^bNZbg
//	AfxGetApp()->WriteProfileInt(sectionName,"CharSet",lplf->lfCharSet);		//tHg̃LN^ZbgZbg
//	AfxGetApp()->WriteProfileInt(sectionName,"PitchAndFamily",lplf->lfPitchAndFamily);	//tHg̃sb`t@~Zbg
	AfxGetApp()->WriteProfileString(sectionName,"FaceName",lplf->lfFaceName);	//tHgFaceNameZbg
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
//O[oϐ
CBSchFont* g_pFont;		//BSchtHg`NX


//////////////////////////////////////////////////////////////////////
//O[o֐

#define COMMENT_FONT_SECTION "CommentFont"
//WXgRg̃ftHg̃tHg𓾂
BOOL g_IniReadFontInfo(LPLOGFONT lplf)
{
	return CBSchFont::IniReadFontInfo(COMMENT_FONT_SECTION,lplf,"MS UI Gothic",16);
}

//WXgɃRg̃ftHg̃tHg
BOOL g_IniWriteFontInfo(LPLOGFONT lplf)
{
	return CBSchFont::IniWriteFontInfo(COMMENT_FONT_SECTION,lplf);
}

#define LABEL_FONT_SECTION "LabelFont"
//WXg烉x̃tHg𓾂
BOOL g_IniReadLabelFontInfo(LPLOGFONT lplf)
{
	return CBSchFont::IniReadFontInfo(LABEL_FONT_SECTION,lplf,"Tahoma",9);
}

//WXgɃx̃tHg
BOOL g_IniWriteLabelFontInfo(LPLOGFONT lplf)
{
	return CBSchFont::IniWriteFontInfo(LABEL_FONT_SECTION,lplf);
}

			
			